<?php

namespace main;


class MyMediawiki
{
    public function __construct()
    {
        // Do nothing
    }

    function people_are_alive($people_names): array
    {
        $url_base = "https://en.wikipedia.org/w/api.php?";
        $url_param = array(
            "action" => "query",
            "format" => "json",
            "prop" => "categories",
            "cllimit" => 500,  # Record is 252 categories, so setting to 500 is fine
            "titles" => implode("|", $people_names)
        );

//        ini_set("user_agent", "death-notifier/%%VERSION_NUMBER%% (https://git.fwdekker.com/tools/death-notifier; florine@fwdekker.com)");
        $data = file_get_contents($url_base . http_build_query($url_param));
        $json = json_decode($data, associative: true);

        $json_pages = array_values($json["query"]["pages"]);
        return array_combine(array_column($json_pages, "title"),
            array_map(fn($categories): bool => in_array("Category:Living people", array_map(fn($it): string => $it["title"], $categories)), array_column($json_pages, "categories"))
        );
    }
}
